var app = angular.module('ionicApp', ['ionic']);

app.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
    .state('tabs', {
        url: "/tab",
        abstract: true,
        templateUrl: "templates/tabs.html"
    })
    .state('tabs.news', {
        url: "/news",
        views: {
            'news-tab': {
                templateUrl: "templates/news.html",
                controller: 'NewsTabCtrl'
            }
        }
    })
    .state('tabs.column', {
        url: "/column",
        views: {
            'column-tab': {
                templateUrl: "templates/column.html",
                controller: "ColumnTabCtrl"
            }
        }
    })
    .state('tabs.news_reader', {
        url: "/news_reader?type&id",
            views: {
            'news-tab': {
                templateUrl: "templates/reader.html",
                controller: "ReaderTabCtrl"
            }
        }
    })
  .state('tabs.column_reader', {
        url: "/column_reader?type&id",
            views: {
            'column-tab': {
                templateUrl: "templates/reader.html",
                controller: "ReaderTabCtrl"
            }
        }
    })
    .state('tabs.tv', {
        url: "/tv",
        views: {
            'tv-tab': {
                templateUrl: "templates/tv.html",
                controller: "TVTabCtrl"
            }
        }
    })
    .state('tabs.radio', {
        url: "/radio",
        views: {
            'radio-tab': {
                templateUrl: "templates/radio.html",
                controller: "RadioTabCtrl"
            }
        }
    });


   $urlRouterProvider.otherwise("/tab/news");

});

app.controller('NewsTabCtrl', function($scope, $http, $ionicLoading, $ionicScrollDelegate) {
    
    $ionicLoading.show({
      template: 'กำลังโหลด...'
    });
    
    var recent_news = $http.get('http://www.smmonline.net/api/news.php?request=more_news&start=0');

    recent_news.success(function(data) {
        $scope.items = data;
        
        setInterval(function(){ 
            $ionicLoading.hide();
        }, 3000);
    });
    
    $scope.doRefresh = function() {
        var recent_news = $http.get('http://www.smmonline.net/api/news.php?request=more_news&start=0');

        recent_news.success(function(data) {
            $scope.items = data;
        });

        recent_news.finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
        });            
    };
    
    $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
        
        $ionicLoading.show({
          template: 'กำลังโหลด...'
        });
    });
    
    $scope.loadMore = function(){
        
        var current_item = document.querySelectorAll('.news_list_title').length;

        var recent_news = $http.get('http://www.smmonline.net/api/news.php?request=more_news&start='+current_item);

        recent_news.success(function(data) {
            
            angular.forEach(data, function(value, key) {
                $scope.items.push(value);
            });
            
        });

        recent_news.finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
        });  
    };
});

app.controller('ColumnTabCtrl', function($scope, $http) {
    
    var recent_article = $http.get('http://www.smmonline.net/api/api.php?action=more_article&start=0');

    recent_article.success(function(data) {
        $scope.items = data;
    });
    
    $scope.doRefresh = function() {
        var recent_article = $http.get('http://www.smmonline.net/api/api.php?action=more_article&start=0');

        recent_article.success(function(data) {
            $scope.items = data;
        });

        recent_article.finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
        });            
    };
    
    $scope.loadMore = function(){
        
        var current_item = document.querySelectorAll('.news_list_title').length;

        var recent_news = $http.get('http://www.smmonline.net/api/api.php?action=more_article&start='+current_item);

        recent_news.success(function(data) {
            
            angular.forEach(data, function(value, key) {
                $scope.items.push(value);
            });
            
        });

        recent_news.finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
        });  
    };
});

app.controller('ReaderTabCtrl', function($scope, $http, $sce, $ionicLoading) {
    
    $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
        
        document.getElementById("NewsBack").style.display = "none";
        document.getElementById("ColumnBack").style.display = "none";
    });
    
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        var item_data;
                
        if(toParams.type == 'news'){
            item_data = $http.get('http://www.smmonline.net/api/api.php?action=get_news&id='+toParams.id);
        }
        else{
            item_data = $http.get('http://www.smmonline.net/api/api.php?action=get_article&id='+toParams.id);
        }

        item_data.success(function(data) {
            
            $scope.ItemIntro    = $sce.trustAsHtml(data.c_intro + data.c_intro_2);
            $scope.ItemContent  = $sce.trustAsHtml(data.c_desc);

            $scope.data = data;
            $scope.type = toParams.type;
            
            if(toParams.type == 'news'){
                document.getElementById("NewsBack").style.display = "block";
            }
            else{
                document.getElementById("ColumnBack").style.display = "block";
            }
            
            setInterval(function(){ 
                $ionicLoading.hide();
            }, 3000);
            
        });
        
    });
    
    $scope.SocialShare = function(){
        //Parameters:
        //Message, Subject, File Path(relative, File URL or file://), URL, success callback, fail callback
        
        if($scope.type == 'article'){
            window.plugins.socialsharing.share($scope.data.c_title, $scope.data.c_intro, null, "http://www.smmsport.com/reader.php?article="+$scope.data.c_id);
        }
        else{
            window.plugins.socialsharing.share($scope.data.c_title, $scope.data.c_intro, null, "http://www.smmsport.com/reader.php?news="+$scope.data.c_id);
        }
        /*
        window.plugins.socialsharing.share($scope.data.c_title, $scope.data.c_intro, null, "http://www.smmsport.com/reader.php?news="+$scope.data.c_id, function(result){
            
        }, function(result){
            
        });
        */
    };
    
});

app.controller('TVTabCtrl', function($scope, $http, $sce) {
    
    $scope.TV_Player = $sce.trustAsHtml('');
    
    if(device.platform == 'Android'){                  
        $scope.playTV = function() {
            window.plugins.videoPlayer.play("http://edge2-bkk.3bb.co.th:1935/smmtv_livestream/smmtv.stream_live1/playlist.m3u8");
        };
    }
    else{
        $scope.playTV = function() {
            window.open('http://edge2-bkk.3bb.co.th:1935/smmtv_livestream/smmtv.stream_live1/playlist.m3u8');
        };
    }
    
    var ads_number          = Math.floor((Math.random() * 10000) + 1);
    
    if(device.platform == 'Android'){
        $scope.TVAds = $sce.trustAsHtml("<a href=\"#\" onclick=\"window.open('http://partners.smmnewscenter.com/www/delivery/ck.php?n=a5e2fff0&amp;cb=" + ads_number + "', '_blank', 'location=yes')\"><img src=\"http://partners.smmnewscenter.com/www/delivery/avw.php?zoneid=133&amp;cb=" + ads_number + "&amp;n=a5e2fff0\" border=\"0\"></a>");
    }
    else{
        $scope.TVAds = $sce.trustAsHtml("<a href=\"#\" onclick=\"window.open('http://partners.smmnewscenter.com/www/delivery/ck.php?n=ac27aa66&amp;cb=" + ads_number + "', '_blank', 'location=yes')\"><img src=\"http://partners.smmnewscenter.com/www/delivery/avw.php?zoneid=136&amp;cb=" + ads_number + "&amp;n=ac27aa66\" border=\"0\"></a>");
    }
});

app.controller('RadioTabCtrl', function($scope, $http, $sce) {
    
    function GetTime(){
        var current_datetime    = new Date();
        var current_hour        = current_datetime.getHours();
        var current_min         = current_datetime.getMinutes();

        if (current_hour < 10) {
            current_hour = "0" + current_hour;
        }

        if (current_min < 10) {
            current_min = "0" + current_min;
        }
        
        return current_hour + ':'+ current_min;
    }
    
    $scope.player_time = GetTime();
    
    function GetStatus(){
    
        var radio_status = $http.get("http://www.smmonline.net/api/api.php?action=recent_onair");

        radio_status.success(function(data, status, headers, config) {
            $scope.radio_status = data;
        });
    }
    
    GetStatus();
    
    setInterval(function(){ 
        
        $scope.player_time = GetTime();
    
    }, 30000);
    
    setInterval(function(){ 
        
        GetStatus();
    
    }, 900000);
    
    var radio_media = null;
    
    if(radio_media) {
        $scope.player_image = 'images/radio_pause.png';
        $scope.player_click = 'stopRadio()';
    }
    else{
        $scope.player_image = 'images/radio_play.png';
        $scope.player_click = 'playRadio()';
    }
    
    $scope.playRadio = function(e) {
        
        if(radio_media) {
            radio_media.pause();
            radio_media = null;
            $scope.player_image = 'images/radio_play.png';
            $scope.player_click = 'playRadio()';
            
            window.plugin.notification.local.cancel(1);
        }
        else{
            radio_media = new Audio('http://110.164.48.215:8000/smmradio');
            radio_media.play();

            $scope.player_image = 'images/radio_pause.png';
            $scope.player_click = 'stopRadio()';
            
            //window.plugin.notification.local.add({id: 1, title: 'SportRadio', message: 'Your are listening..', ongoing: true});
        }
    };
    
    $scope.stopRadio = function(e) {
        if(radio_media) {
            radio_media.stop();
            radio_media.release();
            
            $scope.player_image = 'images/radio_play.png';
            $scope.player_click = 'playRadio()';
        }
    };
    
    var ads_radio_number          = Math.floor((Math.random() * 10000) + 1);
    
    if(device.platform == 'Android'){
        $scope.RadioAds = $sce.trustAsHtml("<a href=\"#\" onclick=\"window.open('http://partners.smmnewscenter.com/www/delivery/ck.php?n=a5e2fff0&amp;cb=" + ads_radio_number + "', '_blank', 'location=yes')\"><img src=\"http://partners.smmnewscenter.com/www/delivery/avw.php?zoneid=133&amp;cb=" + ads_radio_number + "&amp;n=a5e2fff0\" border=\"0\"></a>");
    }
    else{
        $scope.RadioAds = $sce.trustAsHtml("<a href=\"#\" onclick=\"window.open('http://partners.smmnewscenter.com/www/delivery/ck.php?n=ac27aa66&amp;cb=" + ads_radio_number + "', '_blank', 'location=yes')\"><img src=\"http://partners.smmnewscenter.com/www/delivery/avw.php?zoneid=136&amp;cb=" + ads_radio_number + "&amp;n=ac27aa66\" border=\"0\"></a>");
    }
    
    document.addEventListener("pause", function(e){
        if(radio_media){
            window.plugin.notification.local.add({id: 1, title: 'SportRadio', message: 'Your are listening..', sound: null, smallIcon: 'res://icon', ongoing: true});
        }
    }, false);
});